/**
 * Generated by Apache Royale Compiler from org/apache/royale/crux/utils/commands/CommandMap.as
 * org.apache.royale.crux.utils.commands.CommandMap
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.crux.utils.commands.CommandMap');
goog.provide('org.apache.royale.crux.utils.commands.CommandMap.CommandMapping');

goog.require('org.apache.royale.crux.Bean');
goog.require('org.apache.royale.crux.ICrux');
goog.require('org.apache.royale.crux.Prototype');
goog.require('org.apache.royale.crux.reflection.TypeCache');
goog.require('org.apache.royale.crux.utils.commands.ICommand');
goog.require('org.apache.royale.crux.utils.commands.IEventAwareCommand');
goog.require('org.apache.royale.events.Event');
goog.require('org.apache.royale.crux.ICruxAware');
goog.require('org.apache.royale.utils.Language');



/**
 * @constructor
 * @implements {org.apache.royale.crux.ICruxAware}
 */
org.apache.royale.crux.utils.commands.CommandMap = function() {

this.map = {};
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.crux.utils.commands.CommandMap', org.apache.royale.crux.utils.commands.CommandMap);


/**
 * @protected
 * @type {org.apache.royale.crux.ICrux}
 */
org.apache.royale.crux.utils.commands.CommandMap.prototype._crux;


/**
 * @protected
 * @type {Object}
 */
org.apache.royale.crux.utils.commands.CommandMap.prototype.map;


/**
 * Handler method triggered when a mapped event is caught.
 * @protected
 * @param {org.apache.royale.events.Event} event
 */
org.apache.royale.crux.utils.commands.CommandMap.prototype.handleCommandEvent = function(event) {
  if (this.map[event.type] != null) {
    var /** @type {Array} */ indexesToClear = [];
    var /** @type {Array} */ mappings = org.apache.royale.utils.Language.as(this.map[event.type], Array);
    for (var /** @type {number} */ i = 0; i < mappings.length; i++) {
      var /** @type {org.apache.royale.crux.utils.commands.CommandMap.CommandMapping} */ commandMapping = org.apache.royale.utils.Language.as(mappings[i], org.apache.royale.crux.utils.commands.CommandMap.CommandMapping, true);
      if (!org.apache.royale.utils.Language.is(event, commandMapping.eventClass))
        continue;
      var /** @type {org.apache.royale.crux.Bean} */ commandPrototype = this._crux.beanFactory.getBeanByType(commandMapping.commandClass);
      if (commandPrototype == null)
        throw new Error("Command bean not found for mapped event type.");
      if (org.apache.royale.utils.Language.is(commandPrototype, org.apache.royale.crux.Prototype)) {
        var /** @type {Object} */ command = org.apache.royale.utils.Language.as(commandPrototype, org.apache.royale.crux.Prototype, true).source;
        if (!org.apache.royale.utils.Language.is(command, org.apache.royale.crux.utils.commands.ICommand))
          throw new Error("Commands must implement org.apache.royale.crux.utils.commands.ICommand.");
        if (org.apache.royale.utils.Language.is(command, org.apache.royale.crux.utils.commands.IEventAwareCommand))
          org.apache.royale.utils.Language.as(command, org.apache.royale.crux.utils.commands.IEventAwareCommand, true).event = event;
        org.apache.royale.utils.Language.as(command, org.apache.royale.crux.utils.commands.ICommand, true).execute();
      } else {
        throw new Error("Commands must be provided as Prototype beans.");
      }
      if (commandMapping.oneTime)
        indexesToClear.push(i);
    }
    if (indexesToClear.length > 0) {
      for (var /** @type {number} */ j = (indexesToClear.length - 1) >> 0; j > -1; j--) {
        mappings.splice(indexesToClear[j], 1);
      }
      if (mappings.length == 0)
        delete this.map[event.type];
    }
  }
};


/**
 * Abstract method that sub classes should override and populate with calls to <code>mapCommand()</code>.
 * Mapping commands here (and letting it be called for you) ensures all the necessary pieces have
 * been provided before attempting to create any mappings.
 * @protected
 */
org.apache.royale.crux.utils.commands.CommandMap.prototype.mapCommands = function() {
};


/**
 * Method that performs actual event to command mapping.
 * @protected
 * @param {string} eventType
 * @param {Object} commandClass
 * @param {Object=} eventClass
 * @param {boolean=} oneTime
 */
org.apache.royale.crux.utils.commands.CommandMap.prototype.mapCommand = function(eventType, commandClass, eventClass, oneTime) {
  eventClass = typeof eventClass !== 'undefined' ? eventClass : null;
  oneTime = typeof oneTime !== 'undefined' ? oneTime : false;
  if (this.map[eventType] == null) {
    this.map[eventType] = [new org.apache.royale.crux.utils.commands.CommandMap.CommandMapping(eventType, commandClass, eventClass, oneTime)];
  } else {
    var /** @type {Array} */ mappings = org.apache.royale.utils.Language.as(this.map[eventType], Array);
    var foreachiter0_target = mappings;
    for (var foreachiter0 in foreachiter0_target) 
    {
    var cm = foreachiter0_target[foreachiter0];
    {
      if (cm.commandClass == commandClass)
        throw new Error(cm.commandClass + " already mapped to " + eventType);
    }}
    
    mappings.push(new org.apache.royale.crux.utils.commands.CommandMap.CommandMapping(eventType, commandClass, eventClass, oneTime));
  }
  if (this._crux.beanFactory.getBeanByType(commandClass) == null) {
    var /** @type {org.apache.royale.crux.Prototype} */ commandPrototype = new org.apache.royale.crux.Prototype(commandClass);
    commandPrototype.typeDescriptor = org.apache.royale.crux.reflection.TypeCache.getTypeDescriptor(commandClass);
    this._crux.beanFactory.addBean(commandPrototype, false);
  }
  this._crux.dispatcher.addEventListener(eventType, org.apache.royale.utils.Language.closure(this.handleCommandEvent, this, 'handleCommandEvent'));
};


/**
 * @protected
 */
org.apache.royale.crux.utils.commands.CommandMap.prototype.unmapCommands = function() {
  for (var /** @type {string} */ eventType in this.map) {
    this._crux.dispatcher.removeEventListener(eventType, org.apache.royale.utils.Language.closure(this.handleCommandEvent, this, 'handleCommandEvent'));
    delete this.map[eventType];
  }
  this.map = null;
};


org.apache.royale.crux.utils.commands.CommandMap.prototype.set__crux = function(crux) {
  if (crux) {
    this._crux = crux;
    this.mapCommands();
  } else {
    this.unmapCommands();
    this._crux = crux;
  }
};


Object.defineProperties(org.apache.royale.crux.utils.commands.CommandMap.prototype, /** @lends {org.apache.royale.crux.utils.commands.CommandMap.prototype} */ {
/**
  * @export
  * @type {org.apache.royale.crux.ICrux} */
crux: {
set: org.apache.royale.crux.utils.commands.CommandMap.prototype.set__crux}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.crux.utils.commands.CommandMap.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'CommandMap', qName: 'org.apache.royale.crux.utils.commands.CommandMap', kind: 'class' }], interfaces: [org.apache.royale.crux.ICruxAware] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.crux.utils.commands.CommandMap.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    accessors: function () {
      return {
        'crux': { type: 'org.apache.royale.crux.ICrux', access: 'writeonly', declaredBy: 'org.apache.royale.crux.utils.commands.CommandMap'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.crux.utils.commands.CommandMap.prototype.ROYALE_COMPILE_FLAGS = 10;



/**
 * @constructor
 * @param {string} eventType
 * @param {Object} commandClass
 * @param {Object=} eventClass
 * @param {boolean=} oneTime
 */
org.apache.royale.crux.utils.commands.CommandMap.CommandMapping = function(eventType, commandClass, eventClass, oneTime) {
  eventClass = typeof eventClass !== 'undefined' ? eventClass : null;
  oneTime = typeof oneTime !== 'undefined' ? oneTime : false;
  this.eventType = eventType;
  this.commandClass = commandClass;
  this.eventClass = eventClass || org.apache.royale.events.Event;
  this.oneTime = oneTime;
};


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.royale.crux.utils.commands.CommandMap.CommandMapping', org.apache.royale.crux.utils.commands.CommandMap.CommandMapping);


/**
 * @export
 * @type {string}
 */
org.apache.royale.crux.utils.commands.CommandMap.CommandMapping.prototype.eventType;


/**
 * @export
 * @type {Object}
 */
org.apache.royale.crux.utils.commands.CommandMap.CommandMapping.prototype.commandClass;


/**
 * @export
 * @type {Object}
 */
org.apache.royale.crux.utils.commands.CommandMap.CommandMapping.prototype.eventClass;


/**
 * @export
 * @type {boolean}
 */
org.apache.royale.crux.utils.commands.CommandMap.CommandMapping.prototype.oneTime;


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.crux.utils.commands.CommandMap.CommandMapping.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'CommandMapping', qName: 'org.apache.royale.crux.utils.commands.CommandMap.CommandMapping', kind: 'class' }] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.crux.utils.commands.CommandMap.CommandMapping.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'eventType': { type: 'String', get_set: function (/** org.apache.royale.crux.utils.commands.CommandMap.CommandMapping */ inst, /** * */ v) {return v !== undefined ? inst.eventType = v : inst.eventType;}},
        'commandClass': { type: 'Class', get_set: function (/** org.apache.royale.crux.utils.commands.CommandMap.CommandMapping */ inst, /** * */ v) {return v !== undefined ? inst.commandClass = v : inst.commandClass;}},
        'eventClass': { type: 'Class', get_set: function (/** org.apache.royale.crux.utils.commands.CommandMap.CommandMapping */ inst, /** * */ v) {return v !== undefined ? inst.eventClass = v : inst.eventClass;}},
        'oneTime': { type: 'Boolean', get_set: function (/** org.apache.royale.crux.utils.commands.CommandMap.CommandMapping */ inst, /** * */ v) {return v !== undefined ? inst.oneTime = v : inst.oneTime;}}
      };
    },
    methods: function () {
      return {
        'CommandMapping': { type: '', declaredBy: 'org.apache.royale.crux.utils.commands.CommandMap.CommandMapping', parameters: function () { return [ 'String', false ,'Class', false ,'Class', true ,'Boolean', true ]; }}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.crux.utils.commands.CommandMap.CommandMapping.prototype.ROYALE_COMPILE_FLAGS = 10;